﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Bootstrap.MVC.Common;
using Bootstrap.MVC.Infrastructure.ClientEvent;

namespace Bootstrap.MVC.Widgets
{
    public class ButtonModel :  EventHandlerModelBase,  IButtonModel
    {
        public string Caption
        {
            get { return base.Text; }
            set { base.Text = value; }
        }

        public ButtonSize Size { get; set; }
        
        public bool Block { get; set; }
        
        public string Icon { get; set; }
        
        public LeftOrRight IconPosition { get; set; }
        
        public IconColors IconColor { get; set; }
        
        public Skins Skin { get; set; } 
        

        
        public ButtonModel(ViewContext context) : base(context) {}

        public ButtonModel() {}
    }



    public interface IButtonModel : IEventHandlerModelBase
    {
        string Caption {set; get;}
        ButtonSize Size { get; set; }
        bool Block { get; set; }
        string Icon { get; set; }
        LeftOrRight IconPosition { get; set; }
        IconColors IconColor { get; set; }
        Skins Skin { get; set; }
    }
}
