﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Mvc;
using Bootstrap.MVC.Common;
using Bootstrap.MVC.Infrastructure.ClientEvent;

namespace Bootstrap.MVC.Widgets
{
    public class ButtonDropDownModel :  ModelBase,  IButtonDropDownModel
    {
        public string Caption
        {
            get { return base.Text; }
            set { base.Text = value; }
        }

        //public List<IDropDownItemModel> Items { get; set; }
        public IDropDownMenuModel Menu { set; get;}

        public bool Split { get; set; }

        public bool DropUp { get; set; }

        //TODO - must be moved to base
        public ButtonSize Size { get; set; }

        //TODO - must be moved to base
        public Skins Skin { get; set; } 
        
        //public bool Block { get; set; }
        
        //public string Icon { get; set; }
        
        //public LeftOrRight IconPosition { get; set; }
        
        //public IconColors IconColor { get; set; }
        
        //public ClientEventManager Events { get; set; }


        public ButtonDropDownModel(ViewContext context) : base(context) {
            Menu = new DropDownMenuModel();
        }
        public ButtonDropDownModel()
        {
            Menu = new DropDownMenuModel();
        }
    }



    public interface IButtonDropDownModel : IModelBase
    {
        string Caption {set; get;}
        IDropDownMenuModel Menu { get; set; }
        bool Split { get; set; }
        bool DropUp { get; set; }
        
        ButtonSize Size { get; set; }
        Skins Skin { get; set; }
        //bool Block { get; set; }
        //bool Disabled { get; set; }
        //string Icon { get; set; }
        //LeftOrRight IconPosition { get; set; }
        //IconColors IconColor { get; set; }
       
        //ClientEventManager Events { get; set; }
    }
}
